import tensorflow as tf
from tensorflow.examples.tutorials.mnist import input_data
import numpy as np
import time #import system tools
import os

STARTER_LEARNING_RATE = 1e-4
BATCH_SIZE = 1
NUM_CLASSES = 10
IMAGE_SIZE = 28
IMAGE_PIXELS = IMAGE_SIZE ** 2
OUTPUT_NAMES = ["Upsample/upsample/Reshape_1"]#, Upsample/upsample/Reshape, Upsample/upsample/concat, Upsample/upsample/concat_1"]
MAX_STEPS = 10

isUpsample = False

print('End Init')
def WeightsVariable(shape):
    return tf.Variable(tf.truncated_normal(shape, stddev=0.1, name='weights'))

def BiasVariable(shape):
    return tf.Variable(tf.constant(0.1, shape=shape, name='biases'))

def upsample(x, factor):
    # upsampling using concat and reshape
    with tf.name_scope('upsample'):

        size = x.get_shape().as_list()
        b = size[0]
        c = size[1]
        h = size[2]
        w = size[3]
        x = tf.reshape(x, [b, c, h, w, 1])
        reshape_1 = x
        x = tf.concat([x, x], axis=3)
        concat_1 = x
        x = tf.concat([x, x], axis=4)
        concat_2 = x
        x = tf.reshape(x, (b, c, w * factor, h * factor))

    return x, reshape_1, concat_1, concat_2

def network(images):
    # Convolution 1

    with tf.name_scope('Upsample'):
        up, reshape_1, concat_1, concat_2 = upsample(images, 2)
    return up, reshape_1, concat_1, concat_2, images


def placeholder_inputs(batch_size, c, h, w):
    images_placeholder = tf.placeholder(tf.float32, shape=(batch_size, c, h, w))
    labels_placeholder = tf.placeholder(tf.int32, shape=(batch_size))
    return images_placeholder, labels_placeholder

def fill_feed_dict(image, images_pl, labels_pl):
    feed_dict = {
        images_pl: image,
        labels_pl: np.array([1]),
    }
    return feed_dict

def run(image):
    b, c, h, w = image.shape
    with tf.Graph().as_default():
        images_placeholder, labels_placeholder = placeholder_inputs(BATCH_SIZE, c, h, w)
        up, reshape_1, concat_1, concat_2, input = network(images_placeholder)

        summary = tf.summary.merge_all()
        init = tf.global_variables_initializer()
        gpu_options = tf.GPUOptions(per_process_gpu_memory_fraction=0.5)
        sess = tf.Session(config=tf.ConfigProto(gpu_options=gpu_options))
        summary_writer = tf.summary.FileWriter("/tmp/tensorflow/mnist/log",
                                               graph=tf.get_default_graph())
        test_writer = tf.summary.FileWriter("/tmp/tensorflow/mnist/log/validation",
                                            graph=tf.get_default_graph())
        sess.run(init)
        start_time = time.time()
        feed_dict = fill_feed_dict(image,
                                       images_placeholder,
                                       labels_placeholder)
        upnp, reshape_1np, concat_1np, concat_2np, inpnp = sess.run([up, reshape_1, concat_1, concat_2, input], feed_dict=feed_dict)
        duration = time.time() - start_time
        # return sess

        graphdef = tf.get_default_graph().as_graph_def()
        frozen_graph = tf.graph_util.convert_variables_to_constants(sess,
                                                                    graphdef,
                                                                    OUTPUT_NAMES)
        tf.train.write_graph(frozen_graph, '/home/yedidya/Desktop', "Up.pb", False)
        return tf.graph_util.remove_training_nodes(frozen_graph), upnp, reshape_1np, concat_1np, concat_2np, inpnp
# ones = np.ones((1,1,5,5))
ones = np.array(np.meshgrid(np.arange(1,6), np.arange(1,6)))[0,:,:]
twos = np.array(np.meshgrid(np.arange(1,6), np.arange(1,6)))[1,:,:]
ones = ones.reshape([1,1,5,5])
twos = twos.reshape([1,1,5,5])

image = np.concatenate((ones, 10 * twos, 100 * ones), 1)
tf_model,up , reshape_1, concat_1, concat_2, input = run(image)



# uff_model = uff.from_tensorflow(tf_model, OUTPUT_NAMES, output_filename="model.uff")
# uff_model1 = uff.from_tensorflow(tf_model, OUTPUT_NAMES)

# graphdef = tf_model.graph.as_graph_def()
# frozen_graph = tf.graph_util.convert_variables_to_constants(tf_model.sess,
#                                                                     graphdef,
#                                                                     OUTPUT_NAMES)
# tf.train.write_graph(frozen_graph, "leNet.pb", False)
print("Done")


